import 'dart:convert';
import 'package:uuid/uuid.dart';

final _uuid = new Uuid();

void fauiAssert(bool expr, String message) {
  if (!expr) {
    throw Error.safeToString(message);
  }
}

Map<String, dynamic> parseJwt(String token) {
  final parts = token.split('.');
  if (parts.length != 3) {
    throw Exception('invalid token');
  }

  final payload = _decodeBase64(parts[1]);
  final payloadMap = json.decode(payload);
  if (payloadMap is! Map<String, dynamic>) {
    throw Exception('invalid payload');
  }

  return payloadMap;
}

String _decodeBase64(String str) {
  String output = str.replaceAll('-', '+').replaceAll('_', '/');

  switch (output.length % 4) {
    case 0:
      break;
    case 2:
      output += '==';
      break;
    case 3:
      output += '=';
      break;
    default:
      throw Exception('Illegal base64url string!"');
  }

  return utf8.decode(base64Url.decode(output));
}

String newId() {
  return _uuid.v4();
}

isEmpty(dynamic v) {
  return ["", null, false, 0].contains(v);
}
